<script setup lang="ts">
    import { DemandeIntervention } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeIntervention'
    import { computed, ComputedRef, ref, toValue, watchEffect } from 'vue'
    import SDemandeInterventionForm from './SDemandeInterventionForm.vue'
    import SImageCollectionEditor from '@/shared/document/components/SImageCollectionEditor.vue'
    import { requiredInject } from '@/shared/helpers/types'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { DemandeInterventionApi } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeInterventionApi'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { readonly } from 'vue'
    import { DemandeInterventionMapper } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeInterventionMapper'

    interface Props {
        demandeOriginale: DemandeIntervention
    }

    const props = defineProps<Props>()

    const demandeIntervention = ref<DemandeIntervention>(
        toValue(props.demandeOriginale.clone())
    )

    watchEffect(() => {
        demandeIntervention.value = props.demandeOriginale.clone()
    })

    const addedImagesB64 = ref<string[]>([])
    const removedExistingImagesId = ref<string[]>([])

    const msal = useMsal()
    const demandeInterventionApi = new DemandeInterventionApi(msal)
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const isProcessing = ref<boolean>(false)
    const isDirty = computed(() => {
        return !demandeIntervention.value.equals(props.demandeOriginale)
    })

    async function mettreÀJourDemandeIntervention() {
        isProcessing.value = true
        try {
            const demandeInterventionDto = DemandeInterventionMapper.toEditDto(
                demandeIntervention.value
            )

            await demandeInterventionApi.deleteImages(
                serviceOfferId.value,
                props.demandeOriginale.id,
                removedExistingImagesId.value
            )
            await demandeInterventionApi.addImages(
                serviceOfferId.value,
                props.demandeOriginale.id,
                addedImagesB64.value
            )

            const updatedDemandeIntervention =
                await demandeInterventionApi.update(
                    serviceOfferId.value,
                    props.demandeOriginale.id,
                    demandeInterventionDto
                )

            const laModificationEstUnComplémentDInformation =
                props.demandeOriginale.currentStatus.code ===
                'awaiting_information'
            if (laModificationEstUnComplémentDInformation) {
                await demandeInterventionApi.transitionTo(
                    serviceOfferId.value,
                    props.demandeOriginale.id,
                    'awaiting_validation'
                )
                return updatedDemandeIntervention
            }

            return updatedDemandeIntervention
        } finally {
            isProcessing.value = false
        }
    }

    const demandeInterventionFormRef = ref<InstanceType<
        typeof SDemandeInterventionForm
    > | null>(null)
    const formFieldsAreValid: ComputedRef<boolean> = computed(() => {
        return !!demandeInterventionFormRef.value?.formFieldsAreValid
    })

    defineExpose({
        mettreÀJourDemandeIntervention,
        formFieldsAreValid: readonly(formFieldsAreValid),
        isProcessing: readonly(isProcessing),
        isDirty: readonly(isDirty),
    })
</script>

<template>
    <v-row data-cy="card-modification-demande-intervention">
        <v-col cols="12">
            <s-image-collection-editor
                v-model:added-images-b64="addedImagesB64"
                v-model:removed-existing-images-id="removedExistingImagesId"
                v-model:existing-images="demandeIntervention.images"
            />
        </v-col>

        <v-col cols="12">
            <s-demande-intervention-form
                ref="demandeInterventionFormRef"
                v-model="demandeIntervention"
                :available-equipements="
                    demandeIntervention.relatedEquipement
                        ? [demandeIntervention.relatedEquipement]
                        : []
                "
            />
        </v-col>
    </v-row>
</template>
